Logo AND Algorithmique Numérique Distribuée

Public GIT Repository
Merge branch 'master' of git+ssh://scm.gforge.inria.fr//gitroot/simgrid/simgrid
[simgrid.git] / src / smpi / smpirun.in
index 87b0750..7a33dc2 100755 (executable)
@@ -1,7 +1,6 @@
 #! /bin/sh
 
-# Copyright (c) 2007-2015. The SimGrid Team.
-# All rights reserved.
+# Copyright (c) 2007-2016, The SimGrid Team. All rights reserved.
 
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the license (GNU LGPL) which comes with this package.
 SIMGRID_VERSION="@SIMGRID_VERSION_STRING@"
 SIMGRID_GITHASH="@SIMGRID_GITHASH@"
 
-DEFAULT_LOOPBACK_BANDWIDTH="498000000"
-DEFAULT_LOOPBACK_LATENCY="0.000004"
-DEFAULT_NETWORK_BANDWIDTH="$((26 * 1024 * 1024))"
-DEFAULT_NETWORK_LATENCY="0.000005"
+DEFAULT_LOOPBACK_BANDWIDTH="498000000Bps"
+DEFAULT_LOOPBACK_LATENCY="0.000004s"
+DEFAULT_NETWORK_BANDWIDTH="$((26 * 1024 * 1024))Bps"
+DEFAULT_NETWORK_LATENCY="0.000005s"
 DEFAULT_NUMPROCS="4"
-DEFAULT_POWER="100"
+DEFAULT_SPEED="100flops"
 
 LOOPBACK_BANDWIDTH="${DEFAULT_LOOPBACK_BANDWIDTH}"
 LOOPBACK_LATENCY="${DEFAULT_LOOPBACK_LATENCY}"
 NETWORK_BANDWIDTH="${DEFAULT_NETWORK_BANDWIDTH}"
 NETWORK_LATENCY="${DEFAULT_NETWORK_LATENCY}"
-POWER="${DEFAULT_POWER}"
+SPEED="${DEFAULT_SPEED}"
 
-SIMOPTS="--cfg=surf/precision:1e-9 --cfg=network/model:SMPI --cfg=network/TCP_gamma:4194304"
+PRIVATIZE="--cfg=smpi/privatization:@HAVE_PRIVATIZATION@"
+
+SIMOPTS="--cfg=surf/precision:1e-9 --cfg=network/model:SMPI"
 
 #usage to print the way this script should be called
 usage () {
@@ -32,10 +33,11 @@ usage () {
 Usage: $0 [OPTIONS] -platform <xmldesc> -hostfile <hostfile> program [program-options]
 Options:
   -keep-temps                # don't remove the generated files after execution
-  -wrapper <command>         # use command to run the program (e.g. "valgrind")
+  -wrapper <command>         # use command to run the program (e.g. "valgrind" or "gdb --args")
   -map                       # display the machine on which each process rank is mapped
   -np <numprocs>             # use that amount of processes from the hostfile.
                              # By default, all processes of the hostfile are used.
+  -no-privatize              # Disable the globals privatization, that is activated by default
   -trace-ti                  # activate time independant tracing (for replay, default in smpi_simgrid.txt)
   -trace                     # activate tracing (Paje, default in smpi_simgrid.trace)
   -trace-comment <comment>   # put a comment on the top of the trace file
@@ -45,10 +47,6 @@ Options:
   -trace-viva                # generate configuration for Viva's GraphView
   -trace-file <tracefile>    # name of the tracefile (simgrid_smpi.trace)
   -ext <value>               # additional parameter (reserved)
-  -foreground                # run the child process in the foreground:
-                             # - it can access the terminal;
-                             # - but we cannot stop it when we receive a signal.
-                             # This is useful with -wrapper "gdb --args".
 
   -version                   # Displays the SimGrid version (human readable)
   -git-version               # Displays the git hash of SimGrid
@@ -70,12 +68,18 @@ EXTOPT=""
 WRAPPER=""
 HOSTFILE=""
 HOSTFILETMP=0
+MAPOPT=0
+REPLAY=0
 
 unset pid
-unset foreground ; foreground=0
 
 trapped_signals="HUP INT QUIT ILL ABRT SEGV FPE ALRM TERM USR1 USR2 BUS"
 
+die () {
+    printf '[%s] ** error: %s. Aborting.\n' "$(basename $0)" "$*" >&2
+    exit 1
+}
+
 smpirun_cleanup()
 {
   if [ -z "${KEEP}" ] ; then
@@ -139,105 +143,90 @@ while true; do
         "-platform")
            PLATFORM="$2"
             if [ ! -f "${PLATFORM}" ]; then
-               echo "[`basename $0`] ** error: the file '${PLATFORM}' does not exist. Aborting."
-               exit 1
+                die "the file '${PLATFORM}' does not exist"
             fi
            shift 2
             ;;
         "-hostfile")
            HOSTFILE="$2"
             if [ ! -f "${HOSTFILE}" ]; then
-               echo "[`basename $0`] ** error: the file '${HOSTFILE}' does not exist. Aborting."
-               exit 1
+                die "the file '${HOSTFILE}' does not exist"
             fi
            shift 2
             ;;
-
         "-machinefile")
            HOSTFILE="$2"
             if [ ! -f "${HOSTFILE}" ]; then
-               echo "[`basename $0`] ** error: the file '${HOSTFILE}' does not exist. Aborting."
-               exit 1
+                die "the file '${HOSTFILE}' does not exist"
             fi
            shift 2
             ;;
-
         "-ext")
             EXTOPT="$2"
             shift 2
             ;;
-
+       "-no-privatize")
+           PRIVATIZE=""
+           shift 1
+           ;;
         "-map")
-           MAPOPT="true"
+           MAPOPT=1
             shift 1
             ;;
-
         "-trace")
             TRACE_ACTIVE="true"
             shift 1
             ;;
-
         "-trace-ti")
             TRACE_ACTIVE="true"
             TRACE_TI_ACTIVE="true"
             shift 1
             ;;
-
         "-trace-comment")
             TRACE_COMMENT="$2"
             shift 2
             ;;
-
         "-trace-comment-file")
             TRACE_COMMENT_FILE="$2"
             shift 2
             ;;
-
         "-trace-file")
             TRACE_FILENAME="$2"
             shift 2
             ;;
-
         "-trace-grouped")
             TRACE_GROUPED="true"
             shift 1
             ;;
-
         "-trace-resource")
             TRACE_RESOURCE="true"
             shift 1
             ;;
-
         "-trace-viva")
            TRACE_VIVA="true"
            shift 1
             ;;
-
         "-keep-temps")
            KEEP="true"
+           SIMOPTS="$SIMOPTS --cfg=smpi/keep-temps:yes"
             shift 1
             ;;
-
         "-wrapper")
             WRAPPER="$2"
             shift 2
             ;;
-
         "-help" | "--help" | "-h")
             usage
             exit 0
             ;;
-
         "-version" | "--version" | "-v")
             printf '%b\n' "$SIMGRID_VERSION"
             exit 0
             ;;
-           
         "-git-version" | "--git-version")
             printf '%b\n' "$SIMGRID_GITHASH"
             exit 0
             ;;
-
         "--cfg="*|"--log="*)
             for OPT in ${1#*=}
             do
@@ -246,7 +235,7 @@ while true; do
             shift 1
             ;;
         "-foreground")
-            foreground=1
+            # Nothing to do, compatibility.
             shift 1
             ;;
         *)
@@ -255,11 +244,15 @@ while true; do
     esac
 done
 
-if [ -n "$WRAPPER" ]; then
-    EXEC="$WRAPPER $1"
-else
-    EXEC="$1"
+# check if we still have at least one parameter beyond options
+if [ $# -eq 0 ]
+then
+    echo "Error: no program to execute!"
+    usage
+    exit
 fi
+
+EXEC="$1"
 shift
 
 # steel --cfg and --logs options
@@ -279,10 +272,6 @@ while [ $# -gt 0 ]; do
     esac
 done
 
-
-##-----------------------------------
-
-
 if [ -z "${HOSTFILE}" ] && [ -z "${PLATFORM}" ] ; then
     echo "No hostfile nor platform specified."
     usage
@@ -291,7 +280,7 @@ fi
 
 if [ -z "${HOSTFILE}" ] ; then
     HOSTFILETMP=1
-    HOSTFILE="$(mktemp tmphostXXXXXX)"
+    HOSTFILE="$(mktemp smpitmp-hostfXXXXXX)"
     perl -ne 'print "$1\n" if /.*<host.*?id="(.*?)".*?\/>.*/' ${PLATFORM} > ${HOSTFILE}
     perl -ne 'if (/.*<cluster.*?prefix="(.*?)".*?radical="(.*?)".*?suffix="(.*?)".*/) { 
                 my ($pre,$rad,$post)=($1,$2,$3); 
@@ -305,16 +294,16 @@ if [ -z "${HOSTFILE}" ] ; then
                  }
                }
              } elsif (/<cluster/) {
-               die ("Unparsable cluster tag. Either provide an hostfile yourself or give the attributes prefix, radical and suffix in that order on the <cluster line");
+            die ("Unparsable cluster tag. smpirun uses a primitive regular expression to parse cluster tags. Either provide a hostfile yourself or give the attributes prefix, radical and suffix IN THAT ORDER and ON THE SAME LINE as the opening tag (<cluster)");
              }' ${PLATFORM} >> ${HOSTFILE}
 fi
 UNROLLEDHOSTFILETMP=0
 
 #parse if our lines are terminated by :num_process
-multiple_processes=`grep -c ":" $HOSTFILE`
+multiple_processes=$(grep -c ":" $HOSTFILE)
 if [ "${multiple_processes}" -gt 0 ] ; then
     UNROLLEDHOSTFILETMP=1
-    UNROLLEDHOSTFILE="$(mktemp tmphostXXXXXX)"
+    UNROLLEDHOSTFILE="$(mktemp smpitmp-hostfXXXXXX)"
     perl -ne ' do{ for ( 1 .. $2 ) { print "$1\n" } } if /(.*?):(\d+).*/'  ${HOSTFILE}  > ${UNROLLEDHOSTFILE}
     if [ ${HOSTFILETMP} = 1 ] ; then
         rm ${HOSTFILE}
@@ -323,12 +312,10 @@ if [ "${multiple_processes}" -gt 0 ] ; then
     HOSTFILE=$UNROLLEDHOSTFILE
 fi
 
-
 # Don't use wc -l to compute it to avoid issues with trailing \n at EOF
-hostfile_procs=`grep -c "[a-zA-Z0-9]" $HOSTFILE`
+hostfile_procs=$(grep -c "[a-zA-Z0-9]" $HOSTFILE)
 if [ ${hostfile_procs} = 0 ] ; then
-   echo "[`basename $0`] ** error: the hostfile '${HOSTFILE}' is empty. Aborting." >&2
-   exit 1
+    die "the hostfile '${HOSTFILE}' is empty"
 fi
 
 if [ -z "${NUMPROCS}" ] ; then
@@ -336,25 +323,24 @@ if [ -z "${NUMPROCS}" ] ; then
     NUMPROCS=$hostfile_procs
 fi
 
-
 if [ ${NUMPROCS} -gt ${hostfile_procs} ] ; then
-    echo "You requested to use ${NUMPROCS} processes, but there is only ${hostfile_procs} processes in your hostfile..." >&2
+    echo "You requested to use ${NUMPROCS} ranks, but there is only ${hostfile_procs} processes in your hostfile..." >&2
 fi
 
 ##-------------------------------- DEFAULT or SPECIFIED PLATFORM --------------------------------------
 if [ -z "${PLATFORM}" ]; then
-    PLATFORMTMP="$(mktemp tmpXXXXXX)"
+    PLATFORMTMP="$(mktemp smpitmp-platfXXXXXX)"
 
     cat > ${PLATFORMTMP} <<PLATFORMHEAD
 <?xml version='1.0'?>
-<!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid.dtd">
-<platform version="3">
-<AS id="AS0" routing="Full">
+<!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid/simgrid.dtd">
+<platform version="4.1">
+<zone id="AS0" routing="Full">
 PLATFORMHEAD
 
     i=${NUMPROCS}
     while [ $i -gt 0 ]; do
-        echo "  <host id=\"host$i\" power=\"${POWER}\"/>" >> ${PLATFORMTMP}
+        echo "  <host id=\"host$i\" speed=\"${SPEED}\"/>" >> ${PLATFORMTMP}
         echo "  <link id=\"loop$i\" bandwidth=\"${LOOPBACK_BANDWIDTH}\" latency=\"${LOOPBACK_LATENCY}\"/>" >> ${PLATFORMTMP}
         echo "  <link id=\"link$i\" bandwidth=\"${NETWORK_BANDWIDTH}\" latency=\"${NETWORK_LATENCY}\"/>" >> ${PLATFORMTMP}
         i=$((i - 1))
@@ -375,7 +361,7 @@ PLATFORMHEAD
     done
 
     cat >> ${PLATFORMTMP} <<PLATFORMFOOT
-</AS>
+</zone>
 </platform>
 PLATFORMFOOT
 
@@ -383,22 +369,19 @@ else
     PLATFORMTMP=${PLATFORM}
 fi
 ##-------------------------------- end DEFAULT or SPECIFIED PLATFORM --------------------------------------
-
 ##-------------------------------- DEFAULT APPLICATION --------------------------------------
-APPLICATIONTMP="$(mktemp tmpXXXXXX)"
+APPLICATIONTMP="$(mktemp smpitmp-appXXXXXX)"
 #APPLICATIONTMP="app.xml"
 
-
 cat > ${APPLICATIONTMP} <<APPLICATIONHEAD
 <?xml version='1.0'?>
-<!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid.dtd">
-<platform version="3">
+<!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid/simgrid.dtd">
+<platform version="4.1">
 APPLICATIONHEAD
 
 ##---- cache hostnames of hostfile---------------
 if [ -n "${HOSTFILE}" ] && [ -f ${HOSTFILE} ]; then
     hostnames=$(cat ${HOSTFILE} | tr '\n\r' '  ')
-    NUMHOSTS=$(cat ${HOSTFILE} | wc -l)
 fi
 
 if [ "${EXTOPT}" = "smpi_replay" ]; then
@@ -406,6 +389,7 @@ if [ "${EXTOPT}" = "smpi_replay" ]; then
     if [ -n "${APP_TRACES}" ] && [ -f "${APP_TRACES}" ]; then
         hosttraces=$(cat ${APP_TRACES} | tr '\n\r' '  ' )
         NUMTRACES=$(cat ${APP_TRACES} | wc -l)
+        REPLAY=1
     else
         printf "File not found: %s\n" "${APP_TRACES:-\${APP_TRACES\}}" >&2
         exit 1
@@ -414,15 +398,14 @@ fi
 
 ##----------------------------------------------------------
 ##  generate application.xml with hostnames from hostfile:
-##  the name of host_i (1<=i<=p, where -np p) is the line i
-##  in hostfile (where -hostfile hostfile), or "host$i" if
+##  the name of host_i (1<=i<=p, where -np p) is the line i in hostfile (where -hostfile hostfile), or "host$i" if 
 ##  hostfile has less than i lines.
 ##----------------------------------------------------------
 
-HAVE_SEQ="`which seq 2>/dev/null`"
+HAVE_SEQ="$(which seq 2>/dev/null)"
 
 if [ -n "${HAVE_SEQ}" ]; then
-    SEQ=`${HAVE_SEQ} 0 $((${NUMPROCS}-1))`
+    SEQ=$(${HAVE_SEQ} 0 $(( NUMPROCS - 1)))
 else
     cnt=0
     while [ $cnt -lt ${NUMPROCS} ] ; do
@@ -431,45 +414,44 @@ else
     done
 fi
 
-##---- generate <process> tags------------------------------
+set -- $hostnames
+
+##---- generate <actor> tags------------------------------
+#prepare arguments at once
+for ARG in $PROC_ARGS; do
+  XML_ARGS="${XML_ARGS}""<argument value=\"${ARG}\"/>
+"
+done
 
 for i in ${SEQ}
 do
-    if [ -n "${HOSTFILE}" ]; then
-       j=$(( $i % ${NUMHOSTS} + 1 ))
-    fi
-    ##---- optional display of ranks to process mapping
-    if [ -n "${MAPOPT}" ]; then
-       echo "[rank $i] -> $(echo $hostnames|cut -d' ' -f$j)"
-    fi
+    j=$(( i % hostfile_procs + 1 ))
+    host=$(eval "echo \${$j}")
 
-    if [ -z "$(echo $hostnames|cut -d' ' -f$j)" ]; then
-       host="host"$($j)
-    else
-       host="$(echo $hostnames|cut -d' ' -f$j)"
+    ##---- optional display of ranks to actor mapping
+    if [ ${MAPOPT} = 1 ]; then
+      echo "[rank $i] -> $host"
     fi
-    echo "  <process host=\"${host}\" function=\"$i\"> <!-- function name used only for logging -->" >> ${APPLICATIONTMP}
-    echo "    <argument value=\"1\"/> <!-- instance -->" >> ${APPLICATIONTMP}
-    echo "    <argument value=\"$i\"/> <!-- rank -->" >> ${APPLICATIONTMP}
-    if [ "${EXTOPT}" = "smpi_replay" ]; then
+
+    echo "  <actor host=\"${host}\" function=\"$i\"> <!-- function name used only for logging -->
+    <argument value=\"smpirun\"/> <!-- instance -->
+    <argument value=\"$i\"/> <!-- rank -->" >> ${APPLICATIONTMP}
+    if [ ${REPLAY} = 1 ]; then
         if  [ ${NUMTRACES} -gt 1 ]; then
             echo "    <argument value=\"$(echo $hosttraces|cut -d' ' -f$j)\"/>" >> ${APPLICATIONTMP}
         else
             echo "    <argument value=\"$(echo $hosttraces|cut -d' ' -f1)\"/>" >> ${APPLICATIONTMP}
         fi
     else 
-        for ARG in $PROC_ARGS; do
-            echo "    <argument value=\"${ARG}\"/>" >> ${APPLICATIONTMP}
-        done
+    echo ${XML_ARGS} >> ${APPLICATIONTMP}
     fi
-    echo "  </process>" >> ${APPLICATIONTMP}
+    echo "  </actor>" >> ${APPLICATIONTMP}
 done
 
 cat >> ${APPLICATIONTMP} <<APPLICATIONFOOT
 </platform>
 APPLICATIONFOOT
 ##-------------------------------- end DEFAULT APPLICATION --------------------------------------
-
 ##---------------------- SMPI TRACING OPTIONS ---------------------------------
 if [ -n "${TRACE_ACTIVE}" ]; then
     #define trace filename
@@ -490,7 +472,7 @@ if [ -n "${TRACE_ACTIVE}" ]; then
     fi
 
     if [ -n "${TRACE_COMMENT_FILE}" ]; then
-        TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment_file:${TRACE_COMMENT_FILE}"
+        TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment-file:${TRACE_COMMENT_FILE}"
     fi
 
     if [ -n "${TRACE_GROUPED}" ]; then
@@ -509,7 +491,7 @@ fi
 
 export SMPI_GLOBAL_SIZE=${NUMPROCS}
 if [ -n "${KEEP}" ] ; then
-    echo ${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
+    echo ${EXEC} ${PRIVATIZE} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
     if [ ${HOSTFILETMP} = 1 ] ; then
         echo "Generated hostfile ${HOSTFILE} kept."
     fi
@@ -517,15 +499,39 @@ if [ -n "${KEEP}" ] ; then
         echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} kept." 
     fi
 fi
-if [ "$foreground" = 1 ]; then
-  ${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
-  status=$?
-else
-  ${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP} &
-  pid=$!
-  wait $pid
-  status=$?
-  pid=""
+
+# Execute the process
+#
+# The shell still need to be alive for the duration in order to do some cleanup after the process.
+#
+# We are going through great lengths in order to both keep stdin and be able to handle signals:
+#
+# * The job is launched in the background in order to be able to handle signals.
+#
+# * The FD 3 is used to temporarily store FD 1. This is because the shell connects FD 1 to /dev/null when the command
+#   is launched in the background: this can be overriden in bash but not in standard bourne shell.
+exec 3<&0
+${WRAPPER} "@SMPIMAIN@" ${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP} <&3 3>&- &
+pid=$!
+exec 3>&-
+wait $pid
+status=$?
+pid=""
+
+# Keep temporary files on failures to help debugging
+#
+if [ ${status} -ne 0 ] ; then
+    if [ -z "${KEEP}" ]; then
+        echo ${EXEC} ${PRIVATIZE} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
+        if [ ${HOSTFILETMP} = 1 ] ; then
+            echo "Generated hostfile ${HOSTFILE} kept."
+        fi
+        if [ ${UNROLLEDHOSTFILETMP} = 1 ] ; then
+            echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} kept."
+        fi
+    fi
+    echo "Execution failed with code ${status}."
+    KEEP=true
 fi
 
 smpirun_cleanup